/***************************************************************************
                          kpref.cpp  -  description
                             -------------------
    begin                : Mon Mar  6 14:43:31 EET 2000
    copyright            : (C) 2000 by Azarniy I.V.
    email                : azarniy@usa.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kpref.h"
#include "desktop.h"
#include "deskview.h"
#include "gamer.h"
#include "qtformtorg.h"
#include "debug.h"
#include "qtnewgameu.h"
#include <time.h>
#include <kapp.h>
#include <qapp.h>
#include "papplication.h"
#include "qtfontsel.h"
#include <html.h>
#include <kcharsets.h>
#include <kprocess.h>
#include <pthread.h>
#include "qtnewnetgame.h"
#include "netconst.h"
#include "font.xpm"
#include "paper.xpm"
#include "filesave.xpm"
#include "fileopen.xpm"

#include "newgame.xpm"
#include "netpeer.xpm"
#include "netconnect.xpm"
#include "network_settings.xpm"
char *documentation; //see bottom this file
Kpref *kpref;

Kpref::Kpref() {
	setCaption(i18n("Kpref"));
	setBackgroundColor(darkGreen);
	initMenuBar();
	nflAleradyPainting = nAllReadyHinting = WaitingForMouseUp = 0;
	DeskView = NULL;
	DeskTop = NULL;
	setMouseTracking ( TRUE );
	flthread = 0;
}

void Kpref::init() {
	StatusBar1 =  new QStatusBar (this,"StatusBar1") ;
	DeskView = new TDeskView();
	DeskView -> PaintDevice = this; // &&&
//	DeskTop = new TDeskTop();
//	DeskTop -> DeskView = DeskView;
	DeskTop = new TDeskTop(DeskView);

}

Kpref::~Kpref() {
	delete StatusBar1;
	if (flthread)
			pthread_kill(thread,SIGTERM);	
	delete Formtorg;
	delete DeskView;
	delete DeskTop;
}

void Kpref::initMenuBar()
{
  netgameMenu=new QPopupMenu();
	nMultiGameIDCreate  = netgameMenu->insertItem(QPixmap(netpeer_xpm),i18n("Create net game..."), this, SLOT(slotNewNetGameCreate()), CTRL+Key_M, ID_NEWMULTIGAMECREATE);
	nMultiGameIDConnect = netgameMenu->insertItem(QPixmap(netconnect_xpm),i18n("Connect to net game..."), this, SLOT(slotNewNetGame()), CTRL+Key_J, ID_NEWMULTIGAMECONNECT);
		
  fileMenu=new QPopupMenu();
  fileMenu->insertItem(QPixmap(newgame_xpm),i18n("&New game..."), this, SLOT(slotNewSingleGame()), CTRL+Key_N, ID_NEWSINGLEGAME);
  fileMenu->insertItem(QPixmap(network_settings_xpm),i18n("&Net Game"), netgameMenu);


  nMultiGameInetID = fileMenu->insertItem(i18n("New internet game "), this, SLOT(slotNewiNetGame()), CTRL+Key_I, ID_NEWMULTIGAMEINET);
  fileMenu->insertSeparator();
  fileMenu->insertItem(QPixmap(fileopen),i18n("&Open..."), this, SLOT(slotFileOpen()), CTRL+Key_O, ID_FILE_OPEN);
  nSaveGameID = fileMenu->insertItem(QPixmap(filesave),i18n("&Save"), this, SLOT(slotFileSave()), CTRL+Key_S, ID_FILE_SAVE);
  fileMenu->insertSeparator();
  fileMenu->insertItem(i18n("Quit"), this, SLOT(slotFileQuit()), CTRL+Key_Q, ID_FILE_QUIT);

//	fileMenu->setItemEnabled (nMultiGameID,FALSE);
//	fileMenu->setItemEnabled(nMultiGameInetID,FALSE);
	fileMenu->setItemEnabled(nSaveGameID,FALSE);

  viewMenu=new QPopupMenu();
  viewMenu->setCheckable(true);
  viewMenu->insertItem(QPixmap(paper_xpm),i18n("Score..."), this, SLOT(slotShowBollet()), 0, ID_VIEW_BOLLET);
//  viewMenu->insertItem("Preference...", this, SLOT(slotViewStatusBar()), 0, ID_VIEW_STATUSBAR);
  viewMenu->insertItem(QPixmap(font_xpm),i18n("Set font..."), this, SLOT(slotFontSet()), 0, ID_SET_FONT);


  helpMenu=new QPopupMenu();
  helpMenu->insertItem(i18n("About"), this, SLOT(slotHelpAbout()), 0, ID_HELP_ABOUT);
  menuBar()->insertSeparator();
  helpMenu->insertItem(i18n("Documentation..."), this, SLOT(slotHelpDoc()), 0, ID_HELP_DOC);


  menuBar()->insertItem(i18n("&Game"), fileMenu);
  menuBar()->insertItem(i18n("&Show"), viewMenu);
  menuBar()->insertSeparator();
  menuBar()->insertItem(i18n("&Help"), helpMenu);



}



/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////

void Kpref::slotFontSelected(const QFont& Font) {
	PQApplication -> setFont (Font,TRUE);
	DeskTop -> Repaint();
}

void Kpref::slotFontSet() {
	fs   = new FontSelect(this,"FontSelect");
	fs->setGeometry( QRect( 100, 200, 380, 260 ) );
	fs->exec();
	slotFontSelected(fs->f);
	delete fs;
}

void Kpref::slotFileOpen() {
  QString fileName = QFileDialog::getOpenFileName(0,"*.prf",this);
  if (!fileName.isEmpty())  {
		DeskTop->LoadGame(fileName);
		fileMenu->setItemEnabled(nSaveGameID,TRUE);
		DeskTop ->NetGame = 0;
		DeskTop ->RunGame();
  }
}


void Kpref::slotFileSave() {
	if ( DeskTop ) {
		QString fn = QFileDialog::getSaveFileName(0, "*.prf", this);
		if (!fn.isEmpty())  {      // save the game
			DeskTop ->SaveGame(fn);
		}
	}
}

void Kpref::slotFileQuit() {
	exit(0);
}

void Kpref::slotEndSleep() {
	QEvent Event(Event_Timer);
	qApp->postEvent(this,&Event );
}

void Kpref::slotShowBollet() {
    DeskTop->CloseBullet();
    DeskTop-> nflShowPaper = 1;
    DeskTop->ShowPaper();
    DeskTop->DeskView->mySleep(0);
    DeskView ->ClearScreen();
    DeskTop-> nflShowPaper = 0;
    DeskTop->Repaint();
}
//----------------------------------------------------
void Kpref::slotNewNetGame() { // connect
		qtnewnetgame newnetgame(this,"NewNetGame");
		newnetgame.qservername->setText("computer.domain.com");
		newnetgame.qservername->setEnabled(TRUE);		
		newnetgame.newnetgame->setEnabled(FALSE);
		newnetgame.connectgame->setEnabled(TRUE);
		newnetgame.qport->setText("12346");
		if (	newnetgame.exec() ) {		
			strcpy(servername,newnetgame.qservername->text() );
			serverport = atoi(newnetgame.qport->text() ) ;		
			strcpy(nikname,newnetgame.qnikname->text() );
			strcpy(passwd,newnetgame.qpasswd->text() );

			if (! DeskTop -> ValidateNikAndPassword() ) {
				return;
			}
			
			if ( !DeskTop -> JoinToNetGame() ) {
				return;
			}
			fileMenu->setItemEnabled(nSaveGameID,TRUE);
			DeskTop -> PrepareNetGame();
			DeskTop -> GetNikNames();
			DeskTop -> RunGame();	
			fileMenu->setItemEnabled(nSaveGameID,FALSE);	
		}
}
//----------------------------------------------------
void Kpref::slotNewNetGameCreate() { // create		
		char *kprefservername="localhost";
		qtnewnetgame newnetgame(this,"NewNetGame");
		newnetgame.qservername->setText(kprefservername);
		newnetgame.qservername->setEnabled(TRUE);		
		newnetgame.newnetgame->setEnabled(TRUE);
		newnetgame.connectgame->setEnabled(FALSE);		
		newnetgame.qport->setText("12346");
		if (	newnetgame.exec() ) {		
			strcpy(servername,newnetgame.qservername->text() );
			serverport = atoi(newnetgame.qport->text() ) ;		
			strcpy(nikname,newnetgame.qnikname->text() );
			strcpy(passwd,newnetgame.qpasswd->text() );
			if (! DeskTop -> ValidateNikAndPassword() ) {
				return;
			}
			qtnewgameu newgame(this,"NewParamForNetGame");
			if (  newgame.exec() ) {				
				nBuletScore = newgame.QSpinBox_2 ->value();
				g61stalingrad =  (newgame.StalingradGame->isChecked() == true);
				g10vist = (newgame.TenVist->isChecked() == true);
				globvist = (newgame.VistNonBr->isChecked() == true);	
				port = serverport;
				
				if ( ! strcmp(kprefservername,servername) ) {
				// if  localhost startnewserver else connect and make new game on remote server
					if (pthread_create ( &thread, NULL, servermain, "" )) {
					  QMessageBox::about(this,i18n("Error !"),  i18n("Can't run kprefserver..."));
					}
					flthread = 1;
				}
				
				sleep(1);				
				if ( !DeskTop -> MakeNewNetGame() ) {
					if (flthread == 1)
						pthread_kill(thread,SIGTERM);
					return;
				}				
				fileMenu->setItemEnabled(nSaveGameID,TRUE);
				if (newgame.flProtocol->isChecked () ) {
					strcpy(DeskTop -> ProtocolFileName,newgame.ProtocolFileName ->text() );
					DeskTop -> flProtocol = 1;
					DeskTop -> OpenProtocol();				
				}

				DeskTop -> PrepareNetGame();
				DeskTop -> GetNikNames();
				DeskTop -> RunGame();	
				pthread_kill(thread,SIGTERM);
				flthread = 0;
				fileMenu->setItemEnabled(nSaveGameID,FALSE);					
			}			
		}
}
//----------------------------------------------------
void Kpref::slotNewiNetGame() {
}
//----------------------------------------------------
void Kpref::slotNewSingleGame() {
	qtnewgameu newgame(this,"NewSingleGame");
	if (  newgame.exec() ) {
		if (DeskTop) {
			delete DeskTop;
			delete DeskView;
			DeskView = new TDeskView();
			DeskView -> PaintDevice = this; // &&&
			DeskTop = new TDeskTop();
			DeskTop -> DeskView = DeskView;
			nBuletScore = newgame.QSpinBox_2 ->value();
			g61stalingrad =  (newgame.StalingradGame->isChecked() == true);
			g10vist = (newgame.TenVist->isChecked() == true);
			globvist = (newgame.VistNonBr->isChecked() == true);
			DeskView -> DesktopHeight = height();
			DeskView -> DesktopWidht = width();
			DeskView->ClearScreen();
			if (newgame.flProtocol->isChecked () ) {
				strcpy(DeskTop -> ProtocolFileName,newgame.ProtocolFileName ->text() );
				DeskTop -> flProtocol = 1;
				DeskTop -> OpenProtocol();				
			}			
		}
		fileMenu->setItemEnabled(nSaveGameID,TRUE);
		DeskTop ->NetGame = 0;		
		DeskTop -> RunGame();
	}
}
//-----------------------------------------------------------------------------------------
void  Kpref::mouseMoveEvent ( QMouseEvent *MEvent ) {
    if ( ! nAllReadyHinting ) {
        nAllReadyHinting = 1;
        TGamer *Gamer = (TGamer *) DeskTop -> Gamers->At(DeskTop ->nCurrentMove.nValue);
//        Gamer ->DeskView = DeskView;
				if (Gamer) {
	        Gamer -> HintCard(MEvent->x(),MEvent->y());
	      }
        nAllReadyHinting = 0;
    }
}
//-----------------------------------------------------------------------------------------
void  Kpref::mousePressEvent ( QMouseEvent * MEvent) {
//		int nwait;
    WaitingForMouseUp = 1;
    DeskView -> Event = 1;
//    if (WaitingForMouseUp) {

//        TGamer *Gamer = (TGamer *) DeskTop -> Gamers->At(1);
        TGamer *Gamer = (TGamer *) DeskTop -> Gamers->At(DeskTop ->nCurrentMove.nValue);
//        Gamer ->DeskView = DeskView;
				if (Gamer) {
	        Gamer -> X = MEvent->x();
  		      Gamer -> Y = MEvent->y();
  		    }
        WaitingForMouseUp = 0;
//    }
}
//-----------------------------------------------------------------------------------------
void  Kpref::keyPressEvent ( QKeyEvent * KEvent) {
	if (DeskView)
		DeskView -> Event = 1;
}
//-----------------------------------------------------------------------------------------
void Kpref::paintEvent (QPaintEvent *PaintEvent) {
		if ( !nflAleradyPainting ) {
			nflAleradyPainting = 1;
	    if ( DeskView ) {
  	      DeskView -> DesktopHeight = height();
    	    DeskView -> DesktopWidht = width();
	    }
  	  if ( DeskTop ) {
    	    DeskTop -> Repaint();
//				QRect R=PaintEvent->rect();
//    	    DeskTop -> Repaint(R.left(),R.top(),R.right(),R.bottom());
	    }
			nflAleradyPainting = 0;
		}
}
//-----------------------------------------------------------------------------------------
void Kpref::slotHelpDoc() {
  KApplication::getKApplication()->invokeHTMLHelp("", "");
//		KProcess htmlView;
//		htmlView << "kfmclient" << "openURL" << "file:/usr/local/doc/kpref/kprefrules.html";
//		htmlView.start(KProcess::DontCare);
}
//-----------------------------------------------------------------------------------------
void Kpref::slotHelpAbout() {
  QMessageBox::about(this,i18n("About..."),  IDS_APP_ABOUT );
}

