/***************************************************************************
                          kpref.h  -  description
                             -------------------
    begin                : Mon Mar  6 14:43:31 EET 2000
    copyright            : (C) 2000 by Azarniy I.V.
    email                : azarniy@usa.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KPREF_H
#define KPREF_H


#include <qstring.h>
#include <qpopupmenu.h>
#include <qmainwindow.h>
#include <qaccel.h>
#include <qmenubar.h>
#include <qtoolbar.h>
#include <qpixmap.h>
#include <qtoolbutton.h>
#include <qapp.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qpainter.h>

#include <pthread.h>

#include "resource.h"
#include "desktop.h"
#include "deskview.h"
#include "qtfontsel.h"

//#include "qmystatusbar.h"

extern char *documentation;

class Kpref : public QMainWindow
{
  Q_OBJECT
  
  public:
    Kpref();
    ~Kpref();
    void init();
    void initMenuBar();
		QPainter *p;
		FontSelect *fs;
		pthread_t thread;
		int flthread;
  public slots:
		void slotNewSingleGame();
		void slotNewNetGame();	
		void slotNewNetGameCreate();
		void slotNewiNetGame();			
		void slotShowBollet();
		void slotEndSleep();
    void slotFileOpen();
    void slotFileSave();
    void slotFileQuit();
    void slotHelpAbout();
    void slotHelpDoc();
    void slotFontSet();
    void slotFontSelected(const QFont&);
  private:
		QPopupMenu *netgameMenu;
    QPopupMenu *fileMenu;
    QPopupMenu *viewMenu;
    QPopupMenu *helpMenu;
//    QToolBar *fileToolbar;

	public:
		TDeskTop *DeskTop;
		TDeskView *DeskView;
		int WaitingForMouseUp;
		int nAllReadyHinting;
		int nflAleradyPainting;
		int nMultiGameIDConnect;
		int nMultiGameIDCreate;
		int nMultiGameInetID;
		int nSaveGameID;
		QStatusBar *StatusBar1;
	protected:
		void  paintEvent (QPaintEvent *);
		void  mousePressEvent ( QMouseEvent * );
		void  mouseMoveEvent ( QMouseEvent * );
		void  keyPressEvent ( QKeyEvent * );
};

extern Kpref *kpref;
#endif 

