/***************************************************************************
                          netconst.c  -  description
                             -------------------
    begin                : Fri Jun 9 2000
    copyright            : (C) 2000 by Azarniy I.V.
    email                : azarniy@usa.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef PCLIENT
#include "prfconst.h"
#endif

#include "netconst.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <signal.h>

#ifdef P4LIN
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/wait.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#ifdef PCLIENT
#include <kapp.h>
#include "papplication.h"
#include "kpref.h"
#endif

#endif


#ifdef P4WIN
#include <windows.h>
#include <winbase.h>
#include <winsock2.h>
WSADATA wsaData;

#ifdef PCLIENT
#include <vcl.h>
#pragma hdrstop
#include "wp32.h"
#endif
#endif

#ifdef PCLIENT
#include "desktop.h"
#include "deskview.h"
//int flforceserver = 0;
#else
//int flforceserver = 1;
#endif


#ifdef PCLIENT
char waitstate='/';

void ProcessGUIMessages(void) {
	char oldmess[1024];
	char newmess[1024];
	newmess[0]=' ';
	newmess[1]=0;
	switch (waitstate) {
		case '/': waitstate='-'; break;
		case '-': waitstate='\\'; break;
		case '\\': waitstate='|'; break;
		case '|': waitstate='/'; break;
		default : waitstate='/';
	}
	newmess[0]=waitstate;
	#ifdef P4WIN
		strcpy(oldmess,Form1->StatusBar1->SimpleText.c_str() );
		strcat(newmess,oldmess );

		Form1->StatusBar1->SimpleText=newmess;
		Form1->StatusBar1->Update();
		Application->ProcessMessages();
		Sleep(PEVENTMILLISECOND);
		Form1->StatusBar1->SimpleText=oldmess;
	#endif
	#ifdef P4LIN
//		strcpy(oldmess,kpref->StatusBar1->SimpleText );
//		strcat(newmess, "Wait for network move" );
//		kpref->StatusBar1->message(newmess);
//		PQApplication->processOneEvent ( );
		PQApplication->processEvents ( PEVENTMILLISECOND );		
//		kpref->StatusBar1->message(oldmess)
;
	#endif
}

#endif

int read_from_socket ( int connected_socket, char *buffer, int bytes,int blockingio ) {
	int bytescount,bytesread,flread;
	#ifdef P4WIN
	u_long argp=1;
	if ( !blockingio) {
		ioctlsocket(connected_socket,FIONBIO,&argp);
	}
	#endif
	bytesread = bytescount = 0;
	flread = 1;
	while (flread) {
		#ifdef P4LIN
		if ( !blockingio ) {
			bytesread = recv(connected_socket, buffer, bytes,MSG_PEEK|MSG_DONTWAIT);
		} else {
			bytesread = recv(connected_socket, buffer, bytes,MSG_PEEK);
		}
		#endif
		#ifdef P4WIN
		bytesread = recv(connected_socket, buffer, bytes,MSG_PEEK);
		#endif
		switch (bytesread) {
	    case 0: {
				#ifdef PCLIENT
				if ( !blockingio ) {
					ProcessGUIMessages();
				}
				#endif	
				break;
	    }
	    case -1: {
				#ifdef PCLIENT
				if ( !blockingio ) {
					ProcessGUIMessages();
				}
				#endif		
				break;
	    }
	    default:
		if ( strchr(buffer,'\n') ) {				// may be many \n in buff , but read until first !
		    #ifdef P4LIN
		    bytesread = read(connected_socket, buffer,strchr(buffer,'\n')-buffer +1);
		    #endif
		    #ifdef P4WIN
		    bytesread = recv(connected_socket, buffer, strchr(buffer,'\n')-buffer +1,0);
		    #endif
		    bytescount += bytesread;
//		    printf("\n***********%s************",buffer);
		    fflush(NULL);
		    flread = 0;
		}
	        break;
	}
    } // end read
    #ifdef P4WIN
		argp=0;
		if ( !blockingio ) {
  		  ioctlsocket(connected_socket,FIONBIO,&argp);
  		}
    #endif
    return bytescount;
}
//--------------------------------------------------------
int get_connection(int s) {
	int t;  /* socket of connection */
  if ((t = accept(s,NULL,NULL)) < 0)   /* accept connection if there is one */
    return(-1);
  return(t);
}
//--------------------------------------------------------
int establish(unsigned short portnum){
	char   myname[100+1];
  int    s;
  struct sockaddr_in sa;
  struct hostent *hp;

  memset(&sa, 0, sizeof(struct sockaddr_in)); /* clear our address */
  gethostname(myname, 100);           /* who are we? */
  hp= gethostbyname(myname);                  /* get our address info */
  if (hp == NULL)                             /* we don't exist !? */
    return(-1);
  sa.sin_family= hp->h_addrtype;              /* this is our host address */
  sa.sin_port= htons(portnum);                /* this is our port number */

  if ((s= socket(AF_INET, SOCK_STREAM, 0)) < 0) /* create socket */
    return(-1);
  if (bind(s,(struct sockaddr *)&sa,sizeof(struct sockaddr_in)) < 0) {
    #ifdef P4LIN
    close(s);
  #endif
  #ifdef P4WIN
    closesocket(s);
  #endif


    return(-1);                               /* bind address to socket */
  }
  listen(s, 9);                               /* max # of queued connects */
  return(s);
}
//--------------------------------------------------------
int write_to_socket ( int connected_socket, char *buffer, int bytes ) {
  int bytescount;
  int byteswrote;

  bytescount = 0;
  byteswrote  = 0;

  while (bytescount < bytes) {
//    if ((byteswrote = write(connected_socket, buffer, bytes-bytescount)) > 0) {
  #ifdef P4LIN
    if ((byteswrote = write(connected_socket, buffer, bytes-bytescount)) > 0) {
  #endif
  #ifdef P4WIN
    if ((byteswrote = send(connected_socket, buffer, bytes-bytescount,0)) > 0) {
  #endif

      bytescount += byteswrote;
      buffer += byteswrote;
       }
    else if (byteswrote < 0)
      return(-1);
  }
  return( bytescount );
}
//--------------------------------------------------------
struct in_addr *atoaddr(char *address) {
	struct hostent *host;
	static struct in_addr saddr;
	
// First try it as aaa.bbb.ccc.ddd.

	saddr.s_addr = inet_addr(address);
	
	if (saddr.s_addr != -1) {
		return &saddr;
	}
	host = gethostbyname(address);
	if (host != NULL) {
		return (struct in_addr *) *host->h_addr_list;
	}
	return NULL;
}
//--------------------------------------------------------
int connect_to_socket (char host_ip_number[20],  unsigned short port_number) {
  int sockfd,local_h_err_no;
  struct hostent *he;
  struct sockaddr_in their_addr;	/* connector's address information */
  struct in_addr *mni_addr;
  int fladdr = 0;
  if ((he = gethostbyname (host_ip_number)) == NULL) {
      local_h_err_no =h_errno;
      if ((he = gethostbyaddr (host_ip_number,4,PF_INET)) == NULL) {
					local_h_err_no =h_errno;
					// try not resolve
					if ((mni_addr = atoaddr(host_ip_number))==NULL) 
						return (-1);
					fladdr = 1;


      }
  }
  
  if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) == -1) {
  		return (-1);
  }
  their_addr.sin_family = AF_INET;	/* host byte order */
  their_addr.sin_port = htons (port_number);	/* short, network byte order */
  if  (fladdr)  {
	  their_addr.sin_addr = *mni_addr;
  } else {

	  their_addr.sin_addr = *((struct in_addr *)he->h_addr);
  }

  memset (&(their_addr.sin_zero),0, 8);


  if (connect (sockfd, (struct sockaddr *) &their_addr,sizeof (struct sockaddr)) == -1) {
  		return (-1);
  }
  return (sockfd);
}
//------------------------------------------------
#ifdef P4WIN
void cleannetinmustdie(void) {
    WSACleanup();
}
//--------------------------------------------------------
int initnetinmustdie (void) {
    WORD wVersionRequested;
    wVersionRequested = MAKEWORD( 2, 0 );
    if ( WSAStartup( wVersionRequested, &wsaData ) )
        return 0;
    return 1;
}
#endif




/*const char *give_local_IP ( ) {
	char hostname[100];
	struct hostent *h;
	gethostname ( hostname, 100);
	if ((h=gethostbyname(hostname)) == NULL) {
		herror("gethostbyname");
	}
	return( inet_ntoa(*((struct in_addr *)h->h_addr)));
}
//--------------------------------------------------------
const char *give_local_hostname( ) {
	char hostname[100];
	struct hostent *h;
	gethostname ( hostname, 100);
	if ((h=gethostbyname(hostname)) == NULL) {
		herror("gethostbyname");
	}
	strcpy(hostname, h->h_name );
	return ( hostname );
}
//--------------------------------------------------------
int server_start (void) {
	int transf_bytes;
	char buf[MAXDATASIZE];
	char local_ip_address[20];
	char peer_ip_address[20];*/
//	print_header ();
/*	strcpy (local_ip_address, give_local_IP ());
	printf ("\nServer starting on %s\n",local_ip_address);	
	server_write_sock = establish_listening_socket (SERVER_PORT_NUMBER, peer_ip_address);*/
//	transf_bytes = write_to_socket (server_write_sock, player1_name, 20);
//	sleep ( 2 );
//	server_read_sock = connect_to_socket (peer_ip_address, CLIENT_PORT_NUMBER);
//	transf_bytes = read (server_read_sock, player2_name, 20);
//	sleep ( 3 );
//print_header ();
//	printf ("\n   Who will start first ? (random selection)\n\n");
//who_starts = who_start_first ();
/*	if (who_starts == 1) {
		printf ("   %s will start first !\n", player1_name);
		transf_bytes = write_to_socket (server_write_sock, player1_name, 20);
	} else if (who_starts == 2) {
		printf ("   %s will start first !\n", player2_name);
		transf_bytes = write_to_socket (server_write_sock, player2_name, 20);
	}
	printf ("\n   Starting game...\n");
	sleep ( 2 );*/
//	init_server_network_game ();
//}


