/***************************************************************************
                          netconst.h  -  description
                             -------------------
    begin                : Fri Jun 9 2000
    copyright            : (C) 2000 by Azarniy I.V.
    email                : azarniy@usa.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//--------------------------------------------
// net definnnition
//--------------------------------------------
#ifndef NETCONST_H
#define NETCONST_H

#ifdef __BORLANDC__
#define P4WIN
#else
#define P4LIN
#define FONTSIZE 10
#endif

#ifdef PCLIENT
#include "prfconst.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <signal.h>
#include <sys/types.h>

#ifdef P4LIN
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#endif
#ifdef P4WIN
#include <windows.h>
#include <winbase.h>
#include <winsock2.h>
#endif


#define SERVER_PORT_NUMBER  12346
#define MAXDATASIZE  1024
#define MAXGAMERS 2
#define KPSIGN "KPREFSERVER01\n"
#define CONNECTSIGN "CONNECT TO KPREFSERVER01 OK\n"


#define ALLOK 1
//#define NEWDESKREJECT "E1    .    ."
//#define EXISTDESKREJECT "E2   .   ."

enum TPrefCmd {
	SayGame = 1, // int
	SayWord, // char * until \n
	SayCard, // int
	OpenCard, //
	GetCard, // int
	GetCards, // int...until \n
	GetPrikup, // int int
	EOC,
	EOP
};


typedef struct {
	int localnumber;
	int globalnumber;
	char nik[MAXDATASIZE];
	char passwd[MAXDATASIZE];
	int socet;
	int socketleft;
	int socketright;	
	int GamesType;
	int nBullet;	
} Tnetgamer;
	
typedef struct {
	int nowmove; //   
	int start; //   
	int status; /*0 empty 1 wait for gamers 2 work 3 must die*/
	char exstatus[MAXDATASIZE];
	int desk;
	Tnetgamer netgamer[4];
	char name[MAXDATASIZE];
	//  
	int nBullet;
	int g61stalingrad;
	int g10vist;
	int globvist;
	int coloda[32];
	int MaxGame;
	time_t timeoflastmove;
} Ttabula ; //  . - 

extern int port;
// for master
void termination_handler (int signum);
// for children
void termination_handler_children (int signum);
int establish(unsigned short portnum);
int get_connection(int s);
void fireman(int signum);
int write_to_socket ( int connected_socket, char *buffer, int bytes );
int read_from_socket ( int connected_socket, char *buffer, int bytes , int blockingio );
struct in_addr *atoaddr(char *address);
int connect_to_socket (char host_ip_number[20],  unsigned short port_number);

int join(int t);

//   
int makenewtabula(int t,char *nik,char *passwd,int localnumber);
//    (  )
int gamer2desk(int desk,int t,char *nik,char *passwd,int localnumber);
//   
int getnoncomplecttabula(int t,char *nik,char *passwd,int localnumber);
//  
int pipeconnect (int t,int todesk,int localnumber,int masterglobalnumber);
//   
int sendconnect(int t);
//   
int masterjob(int t);
//  
int slavejob(int t);	
//  
int superslavejob(int t);
// -=   
Tnetgamer *getnetgamerbysocket(int t);
// -=   
Ttabula	*getdeskbysocket(int t);
//  
void makecoloda(Ttabula	*tabula);
int endoftorg(Ttabula	*);
int isnewcompletedesk(int t);
int getleftsocket(int gnum,	Ttabula *tabula);
int getrightsocket(int gnum,	Ttabula *tabula);
int write_to_gamer(Ttabula *tabula,int i,char *buff);
int hose_to_gamer(Ttabula *tabula,int i,char *buff);
//   
int stataftercircle(Ttabula *tabula);
int whonext(Ttabula *tabula);
int endofgame (Ttabula *tabula);
//   
void kprefserverstat(void);
void usage (char *);
void killdesk(void);
#ifdef P4WIN
extern int initnetinmustdie (void);
extern void cleannetinmustdie(void);
extern WSADATA wsaData;
#endif

#ifdef PCLIENT
#ifdef P4LIN
extern void *servermain (char *argv[]);
#endif
#ifdef P4WIN
unsigned long __stdcall  servermain (void *argv);
#endif

void ProcessGUIMessages(void);
#endif

//extern int flforceserver;

#endif