#include <string.h>
#include "prfconst.h"
#include "card.h"
#ifdef P4LIN
#include "kapp.h"
#endif
//--------------------------------------------------------------------------
typedef struct {
 TGamesType GamesType;
 const char *name;
}  TGameName;
//--------------------------------------------------------------------------
#ifdef P4LIN
TGameName GameName[31];
#endif

#ifdef P4WIN

#include <windows.h>
#include <winbase.h>
#include <winsock2.h>
//WSADATA wsaData;
//#pragma  warn -pin

TGameName GameName[] = {
  {g86catch,"                   "},
  {raspass,"                "},
  {undefined,"-------------------"},
  {vist,"               "},
  {pass,"                "},
  {g61,"           "},
  {g62,"          "},
  {g63,"         "},
  {g64,"        "},
  {g65,"     "},
  {g71,"            "},
  {g72,"           "},
  {g73,"          "},
  {g74,"         "},
  {g75,"      "},
  {g81,"          "},
  {g82,"         "},
  {g83,"        "},
  {g84,"       "},
  {g85,"    "},
  {g86,"              "},
  {g91,"          "},
  {g92,"         "},
  {g93,"        "},
  {g94,"       "},
  {g95,"    "},
  {g101,"         "},
  {g102,"        "},
  {g103,"       "},
  {g104,"      "},
  {g105,"   "}
};
//#pragma  warn +pin
#endif
//--------------------------------------------------------------------------
int g61stalingrad;
int g10vist;
int globvist;
int nBuletScore;
TGamesType CurrentGame;

char servername[100];
unsigned int serverport;
char nikname[100];
char passwd[100];

//--------------------------------------------------------------------------
#ifdef P4LIN
//  - spades  - diamonds  - clubs
//  - hearts
//  - pass
//  - trump
// 
void InitGameNameFori18n(void) {
	GameName[0].GamesType = g86catch;		GameName[0].name = i18n("                   ");
	GameName[1].GamesType = raspass;		GameName[1].name = i18n("Pass               ");
	GameName[2].GamesType = undefined;	GameName[2].name = i18n("-------------------");
	GameName[3].GamesType = vist;       GameName[3].name = i18n("Whist              ");
	GameName[4].GamesType = pass;     	GameName[4].name = i18n("Pass               ");
	GameName[5].GamesType = g61;     		GameName[5].name = i18n("Six of spades      ");
  GameName[6].GamesType =g62;					GameName[6].name = i18n("Six of clubs       ");
  GameName[7].GamesType =g63;					GameName[7].name = i18n("Six of diamonds    ");
  GameName[8].GamesType =g64;					GameName[8].name = i18n("Six of hearts      ");
  GameName[9].GamesType =g65;					GameName[9].name = i18n("Simply Six         ");
  GameName[10].GamesType =g71;				GameName[10].name =i18n("Seven of spades    ");
  GameName[11].GamesType =g72;				GameName[11].name =i18n("Seven of clubs     ");
  GameName[12].GamesType =g73;				GameName[12].name =i18n("Seven of diamonds  ");
  GameName[13].GamesType =g74;				GameName[13].name =i18n("Seven of hearts    ");
  GameName[14].GamesType =g75;				GameName[14].name =i18n("Simply Seven       ");
  GameName[15].GamesType =g81;				GameName[15].name =i18n("Eight of spades    ");
  GameName[16].GamesType =g82;				GameName[16].name =i18n("Eight of clubs     ");
  GameName[17].GamesType =g83;				GameName[17].name =i18n("Eight of diamonds  ");
  GameName[18].GamesType =g84;				GameName[18].name =i18n("Eight of hearts    ");
  GameName[19].GamesType =g85;				GameName[19].name =i18n("Simply Eight       ");
  GameName[20].GamesType =g86;				GameName[20].name =i18n("Miser              ");
  GameName[21].GamesType =g91;				GameName[21].name =i18n("Nine of spades     ");
  GameName[22].GamesType =g92;				GameName[22].name =i18n("Nine of clubs      ");
  GameName[23].GamesType =g93;				GameName[23].name =i18n("Nine of diamonds   ");
  GameName[24].GamesType =g94;				GameName[24].name =i18n("Nine of hearts     ");
  GameName[25].GamesType =g95;				GameName[25].name =i18n("Simply Nine        ");
  GameName[26].GamesType =g101;				GameName[26].name =i18n("Ten of spades      ");
  GameName[27].GamesType =g102;				GameName[27].name =i18n("Ten of clubs       ");
  GameName[28].GamesType =g103;				GameName[28].name =i18n("Ten of diamonds    ");
  GameName[29].GamesType =g104;				GameName[29].name =i18n("Ten of hearts      ");
  GameName[30].GamesType =g105;				GameName[30].name =i18n("Simply Ten         ");
}
#endif
//--------------------------------------------------------------------------
int nGetKoz(void) {
	return CurrentGame - (CurrentGame/10) * 10;
}
//--------------------------------------------------------------------------
int NextGame(TGamesType GamesType) {

  if ( GamesType == g86 )  {
    return g91;
  }
  if (GamesType == g105 )  {
    return GamesType;
  }
  if (GamesType == pass )  {
  		return g61;
  }
  if ( GamesType != undefined )  {
    int vz = GamesType/10,mast = GamesType - vz*10;
    if ( mast != 5 ) {
      mast++;

    } else {
      mast = pica;
      vz ++;
    }
    return vz*10+mast;
  } else {
  		return g61;
  }
  return pass;
}
//--------------------------------------------------------------------------

char *sGameName(TGamesType GamesType) {
   for (unsigned int i=0;i<=sizeof(GameName)/sizeof(TGameName);i++) {
      if (GameName[i].GamesType == GamesType) return (char *) GameName[i].name;
   }
   return "                 ";
}
//--------------------------------------------------------------------------
int nGetGameCard(TGamesType gType) {
   if ( gType >=g71 && gType <= 75)   return 7;
   if ( gType >=g81 && gType <= 85)   return 8;
   if ( gType ==g86)                  return 0;
   if ( gType >=g91 && gType <= 95)   return 9;
   if ( gType >=g101 && gType <= 105) return 10;
   return 6;
}
//--------------------------------------------------------------------------
int nGetVistCard(TGamesType gType) {
   if ( gType >=g71 && gType <= 75)   return 2;
   if ( gType >=g81 && gType <= 85)   return 1;
   if ( gType ==g86)                  return 0;
   if ( gType >=g91 && gType <= 95)   return 1;
   if ( gType >=g101 && gType <= 105) return 1;
   return 4;
}
//--------------------------------------------------------------------------
int nGetMinCard4Vist(TGamesType gType) {
   if ( gType >=g71 && gType <= 75)   return 2;
   if ( gType >=g81 && gType <= 85)   return 1;

   if ( gType ==g86)                  return 0;
   if ( gType >=g91 && gType <= 95)   return 1;
   if ( gType >=g101 && gType <= 105) return 0;
   return 3;
}
//--------------------------------------------------------------------------
int nGetGamePrice(TGamesType gType) {
   if ( gType >=g71 && gType <= 75)    return 4;
   if ( gType >=g81 && gType <= 85)    return 6;
   if ( gType ==g86)                   return 10;
   if ( gType >=g91 && gType <= 95)    return 8;
   if ( gType >=g101 && gType <= 105)  return 10;
   return 2;
}
//----------------------------------------------------------------------
TGamesType GamesTypeByName(char *sname) {
  if ( !strcmp("raspass",sname)) return   raspass;
  if ( !strcmp("vist",sname)) return          vist;
  if ( !strcmp("undefined",sname)) return     undefined;
  if ( !strcmp("pass",sname)) return          pass;
  if ( !strcmp("g61",sname)) return           g61;
  if ( !strcmp("g62",sname)) return           g62;
  if ( !strcmp("g63",sname)) return           g63;
  if ( !strcmp("g64",sname)) return           g64;
  if ( !strcmp("g65",sname)) return           g65;
  if ( !strcmp("g71",sname)) return           g71;
  if ( !strcmp("g72",sname)) return           g72;
  if ( !strcmp("g73",sname)) return           g73;
  if ( !strcmp("g74",sname)) return           g74;
  if ( !strcmp("g75",sname)) return           g75;
  if ( !strcmp("g81",sname)) return           g81;

  if ( !strcmp("g82",sname)) return           g82;
  if ( !strcmp("g83",sname)) return           g83;
  if ( !strcmp("g84",sname)) return           g84;
  if ( !strcmp("g85",sname)) return           g85;
  if ( !strcmp("g86",sname)) return           g86;
  if ( !strcmp("g91",sname)) return           g91;
  if ( !strcmp("g92",sname)) return           g92;
  if ( !strcmp("g93",sname)) return           g93;
  if ( !strcmp("g94",sname)) return           g94;
  if ( !strcmp("g95",sname)) return           g95;
  if ( !strcmp("g101",sname)) return          g101;
  if ( !strcmp("g102",sname)) return          g102;
  if ( !strcmp("g103",sname)) return          g103;
  if ( !strcmp("g104",sname)) return          g104;
  if ( !strcmp("g105",sname)) return          g105;
  return     undefined;
}
//----------------------------------------------------------------------
int Card2Int(void *vCard) {
        TCard *Card = (TCard*) vCard;
        if (Card)
                return Card -> CName*10 + Card -> CMast;
        return -1;
}
//----------------------------------------------------------------------
