/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Thu Jun  8 14:43:32 EEST 2000
    copyright            : (C) 2000 by Azarniy I.V.
    email                : azarniy@usa.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef PCLIENT
#include "prfconst.h"
#endif

#include "netconst.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <signal.h>
#include <time.h>
#ifdef P4LIN
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include <sys/shm.h>
#include <sys/ipc.h>

#endif
#ifdef P4WIN
#include "getopt.h"
#include <windows.h>
#include <winbase.h>
#include <winsock2.h>
#endif


char *arg = "h?p:sl:";
char logfile[FILENAME_MAX];
volatile sig_atomic_t keep_going = 1; /* controls program termination */
static int tabulacounter;
Ttabula *tabula;

#ifdef P4WIN
HGLOBAL
#endif
#ifdef P4LIN
int
#endif
shmid;

int port;
//--------------------------------------------------------
#ifdef PCLIENT

#ifdef P4LIN
void *servermain (char *argv[]) {
	int argc;
#endif
#ifdef P4WIN
unsigned long __stdcall servermain (void *argv) {
	int argc;
#endif
#else
int main (int argc, char *argv[]) {
#endif
	int s, t,flstat;
	int ch;
	void  *segptr;
	#ifdef P4LIN
	key_t key;
	#endif
	#ifdef P4WIN
	DWORD merr;
	#endif
	#ifdef PCLIENT
	argc = 1; // name -p port
	
	#else
	port = SERVER_PORT_NUMBER;
	// client must sets port number 	
	#endif
//	flforceserver = 1; // flforceserver already 0 , but if server start from servermain or main flforceserver must be 1;
		
	flstat = tabulacounter = 0;

	#ifdef P4LIN
// param only in linux
	while ( (ch = getopt(argc,argv,arg) ) !=-1) {
		switch (ch) {
			case 'h':
			case '?':
				usage(argv[0]);
				#ifdef PCLIENT
				return NULL;
				#else
				return 1;
				#endif
			case 'p':
				port = (int ) strtol(optarg,NULL,10);
				break;
			case 'l':
				strncpy(logfile,optarg,FILENAME_MAX);
				break;
			case 's':
				flstat = 1;
				break;
		}
	}
	#endif

	#ifdef P4LIN
	key = ftok(".", 'S');
	if (key < 0 )
		perror("\nftok cant return key");
	if((shmid = shmget(key, MAXGAMERS*sizeof(Ttabula), IPC_CREAT|IPC_EXCL|0666)) == -1) {
//		printf("\nClient for shared memory\n");    /* Segment probably already exists - try as a client */
		if((shmid = shmget(key, MAXGAMERS*sizeof(Ttabula), 0)) == -1) {
			perror("shmget");
			exit(1);
		}
	} else {
//		printf("\nMaster for shared memory\n");
	}
   /* Attach (map) the shared memory segment into the current process */
	segptr = shmat(shmid, 0, 0);
	if((int )segptr == -1)  {
		perror("shmat");
		exit(1);
	}
  	#endif
  	
	#ifdef P4WIN
// space for allocate and attach or only attach to share mem
	#ifndef PCLIENT
// client already the init network
	if (!initnetinmustdie()) {
		exit(1);
	}
	#endif
/*  if ( (shmid = GlobalAlloc(MAXGAMERS*sizeof(Ttabula),GMEM_SHARE|GMEM_FIXED |GMEM_ZEROINIT ))==NULL) {
    exit(1);
	}
	segptr = GlobalLock(shmid);
	if (segptr==NULL){
		merr = GetLastError();
		GlobalFree(shmid);
		exit(1);
  }*/
    if ( (segptr = malloc(MAXGAMERS*sizeof(Ttabula))) == NULL )
      exit(1);
  	#endif

	tabula = (Ttabula *) segptr;

	if (flstat) {
		kprefserverstat();
		termination_handler_children(SIGTERM);
	}
	memset(tabula,0,sizeof(tabula)); //   0

//*******************************************

/*	if (chdir (HOME_DIR)) {
		fprintf (stderr, "`%s': ", HOME_DIR);
		perror (NULL);
		exit (1);
	}*/
	/* Become a daemon: */
/*	switch (fork ()) {
		case -1:                    // can't fork
			perror ("fork()");
			exit (3);
		case 0:                     // child, process becomes a   daemon:
			close (STDIN_FILENO);
			close (STDOUT_FILENO);
			close (STDERR_FILENO);
			if (setsid () == -1) {     // request a new session (job control)
				exit (4);
			}
			break;
		default:                    // parent returns to calling  process:
			return 0;
	}*/
	/* Establish signal handler to clean up before termination: */
	if (signal (SIGTERM, termination_handler) == SIG_IGN) {
		signal (SIGTERM, SIG_IGN);
		signal (SIGINT, SIG_IGN);
		#ifdef P4LIN
		signal (SIGHUP, SIG_IGN);
		#endif
	}
	#ifdef P4LIN
	signal(SIGCHLD, fireman);           /* this eliminates zombies */
	#endif
//printf("\n before establ");

	if ((s= establish(port)) < 0) {  /* plug in the phone */
		perror("establish");
		termination_handler(SIGTERM);
		exit(1);
	}
	
//printf("\n Main program loop ");
	while (keep_going) {
		if ((t= get_connection(s)) < 0) { /* get a connection */
			if (errno == EINTR)             /* EINTR might happen on accept(), */
				continue;                     /* try again */
			perror("accept");               /* bad */
			exit(1);
		}
                #ifdef P4WIN
//			printf("\nSocket %i",t);
			if (join(t) == ALLOK ) {
				if ( isnewcompletedesk(t) ) {
					masterjob(t);
				}
			} else {
//				printf("\n\n----------------------------------\n join(%i) != ALLOK\n---------------------------------- \n\n",t);
			}
                #endif
                #ifdef P4LIN
		switch(fork()) {                  /* try to handle connection */
			case -1 :                         /* bad news.  scream and die */
				perror("fork");
				close(s);
				close(t);
				exit(1);
			case 0 :                          /* we're the child, do something */
				close(s);
				// children do not manager of shared memory
				signal (SIGTERM, termination_handler_children);
				//signal (SIGTERM, SIG_IGN);
				signal (SIGINT, SIG_IGN);
				signal (SIGHUP, termination_handler_children);
//				printf("\nSocket %i",t);
				if (join(t) == ALLOK ) {
					if ( isnewcompletedesk(t) ) {
						masterjob(t);
					}
				} else {
//					printf("\n\n----------------------------------\n join(%i) != ALLOK\n---------------------------------- \n\n",t);
				}
				exit(0);
	  		default :                         /* we're the parent so look for */
	//    		  close(t);                       /* another connection */
// and do not close connetction t !!!
	      		continue;
		} // switch
                #endif
	}
	#ifdef P4WIN
        cleannetinmustdie();
	#endif

	return EXIT_SUCCESS;
}
//--------------------------------------------------------
int isnewcompletedesk(int t) {
	int i;
	Ttabula	 *tabula;
//	printf("\n   ");
	tabula = getdeskbysocket	(t);
	for (i = 1; i<=3 ; i++) {
		if ( ! (tabula->netgamer[i].socet && tabula->netgamer[i].socketleft && tabula->netgamer[i].socketright)  ) {
//				printf(" ");
				tabula->status  = 1; // wait for gamers
				return 0;
		}
	}
	tabula->status  = 2;
//	printf(" ");
	return 1;
}
//--------------------------------------------------------
void makecoloda(Ttabula	 *tabula) {
  time_t t;
	char buff[MAXDATASIZE];
	char buff2[MAXDATASIZE];
	int index,i,j,index2,tmp;
	// int g
;
	index = index2 = 0;
	for (i = 1;i<=4;i++) {
		for ( j=7;j<=14;j++) {
			tabula->coloda[index] = j*10+i;
			index++;
		}
	}

	// mix the coloda  needs !!!!
	srand((unsigned) time(&t));
  for ( j=0;j<=3;j++ ) {
      i = rand() % 1234;
      while(i--) {
		      index = rand() % 32;
		      index2 = rand() % 32;
      			tmp = tabula->coloda[index];
      			tabula->coloda[index] = tabula->coloda[index2];
      			tabula->coloda[index2] = tmp;
      }
  }
	index = index2 = 0;
	for ( i = 1;i<=3;i++ ) {
		memset(buff,0,MAXDATASIZE);
		memset(buff2,0,MAXDATASIZE);
//		sprintf(buff,"%i ",GetCards);
		for (index = 0;index <= 9;index++) {
			sprintf(buff2,"%i ",tabula->coloda[index+index2]);
			strcat (buff,buff2);
		}
		index2 += index;
		strcat(buff,"\n");
		//   i  
//		printf("\n  %i  ",i );
		write_to_gamer(tabula, i , buff );
//		printf("   %s",buff);
	}
//	printf("\n-------------------------   ----------------------");
	return;
}
//--------------------------------------------------------
int endoftorg(Ttabula	 *tabula) {
	int passcounter,unknow,j;
	passcounter = unknow = 0;
	for (j = 1;j<=3;j++) {
		if (tabula->netgamer[j].GamesType==60)
			passcounter++;
	}
	for (j = 1;j<=3;j++) {
		if (tabula->netgamer[j].GamesType==59)
			unknow++;
	}
	if ( passcounter > 2 && unknow==0)
		return 1;
	return 0;
}
//--------------------------------------------------------
int masterjob(int t) {
	char buff[MAXDATASIZE];
	int j,i,passcounter,result,indexmaxgame,undefcounter;
//	int c;
//	int tmpval;
//	int card[4];
	Ttabula *tabula;
	undefcounter = passcounter = 0;	
	tabula = getdeskbysocket(t);
	sprintf(tabula->exstatus,"In master");
	tabula->nowmove  = tabula->start = 1;
	sprintf(tabula->exstatus,"Sending niknames");	
	for (j = 1;j<=3;j++)	{
			memset(buff,0,MAXDATASIZE);	
			sprintf(buff,"%s \n",tabula->netgamer[j].nik);
			write_to_socket(getleftsocket(tabula->netgamer[j].globalnumber,tabula),buff,strlen(buff));
			write_to_socket(getrightsocket(tabula->netgamer[j].globalnumber,tabula),buff,strlen(buff));	
	}
	do {
		makecoloda(tabula);
		sprintf(tabula->exstatus,"makecoloda-ok");

		for (j = 1;j<=3;j++)
			tabula->netgamer[j].GamesType=59;	
		do {
			//   2-  
			memset(buff,0,MAXDATASIZE);	
			/////////////////////
			if ( tabula -> netgamer[tabula->nowmove].GamesType != 60 ) {
				sprintf(tabula->exstatus,"read from %i %s socket %i",tabula -> netgamer[tabula->nowmove].globalnumber,tabula -> netgamer[tabula->nowmove].nik,tabula -> netgamer[tabula->nowmove].socet);
				read_from_socket( tabula -> netgamer[tabula->nowmove].socet ,buff,MAXDATASIZE,1 );
				sscanf(buff,"%i",&result);
				tabula -> netgamer[tabula->nowmove].GamesType=result;		
				sprintf(tabula->exstatus,"result = %i\n Writing ro hose",result);
				write_to_socket(getleftsocket(tabula -> netgamer[tabula->nowmove].globalnumber,tabula),buff,strlen(buff) );
				write_to_socket(getrightsocket(tabula -> netgamer[tabula->nowmove].globalnumber,tabula),buff,strlen(buff) );
				sprintf(tabula->exstatus,"...ok");			
				undefcounter = passcounter = 0 ;
				for (j = 1;j<=3;j++) {
					switch (tabula->netgamer[j].GamesType) {
						case 60:	passcounter++; break;
						case 59:	undefcounter++; break;
					}
				}
				sprintf(tabula->exstatus,"passcounter = %i undefcounter = %i",		passcounter ,undefcounter);
			}
			tabula->nowmove ++;
			if (tabula->nowmove==4) tabula->nowmove = 1;				
			if ( passcounter >= 2 && undefcounter==0  )
				break;
		} while (1);
		// .  
		sprintf(tabula->exstatus,"Max game....");
		indexmaxgame = tabula -> MaxGame = 0;
		for (i=1;i<=3;i++) {
			if ( tabula ->MaxGame < tabula -> netgamer[i].GamesType ) {
				indexmaxgame = i;
				tabula ->MaxGame = tabula -> netgamer[i].GamesType;
				sprintf(tabula->exstatus," %i gamer %i",tabula ->netgamer[i].GamesType ,indexmaxgame);
			}			
		}
		if (tabula ->MaxGame != 60) {
			memset(buff,0,MAXDATASIZE);	
			sprintf(buff,"%i %i \n",tabula->coloda[30],tabula->coloda[31]);
			sprintf(tabula->exstatus,"   %i   %s",indexmaxgame,buff);
			write_to_gamer(tabula,indexmaxgame,buff);
			sprintf(tabula->exstatus,"");
			memset(buff,0,MAXDATASIZE);	
			sprintf(tabula->exstatus,"Wait 4 snos");
			hose_to_gamer(tabula,indexmaxgame,buff);
			sprintf(tabula->exstatus,"Write ok %s",buff);	
			// wait for pass or vist from another gamers
			passcounter =0 ;
			indexmaxgame ++;
			if (indexmaxgame==4) indexmaxgame = 1;
			hose_to_gamer(tabula,indexmaxgame,buff);	
			passcounter += ((atoi (buff) == 60) ? 1:0);
			
			indexmaxgame ++;			
			if (indexmaxgame==4) indexmaxgame = 1;
			hose_to_gamer(tabula,indexmaxgame,buff);	
			passcounter += ((atoi (buff) == 60) ? 1:0);
			
			if (passcounter == 2) {
				// 2 gamers say pass :) || :(
				goto paper;
			}						
		} /*else {
			//  		
		}*/
		tabula->nowmove  = tabula->start;
		for (i = 1;i<=10;i++) {
//			if ( tabula -> MaxGame == 60 && ( i==1 || i==2 || i==3) ) {
//				tabula->nowmove  = tabula->start;			
//			}
			if ( tabula ->MaxGame == 60 && ( i==1 || i==2) ) {
				memset(buff,0,MAXDATASIZE);					
				sprintf(buff,"%i \n",tabula->coloda[29+i]);
				sprintf(tabula->exstatus,"raspass card %s",buff);
				sprintf(tabula->exstatus,"sending");
				write_to_socket(tabula -> netgamer[1].socet,buff,strlen(buff));	
				sprintf(tabula->exstatus," 1 ");
				write_to_socket(tabula -> netgamer[2].socet,buff,strlen(buff));	
				sprintf(tabula->exstatus," 2 ");
				write_to_socket(tabula -> netgamer[3].socet,buff,strlen(buff));	
				sprintf(tabula->exstatus," 3 ");
				sprintf(tabula->exstatus,"....sended");
			}
			for (j = 1;j<=3;j++) {
//				printf("\n  Read from %i",tabula->nowmove);
				hose_to_gamer(tabula,tabula->nowmove,buff);
				tabula->nowmove++;
				if (tabula->nowmove==4) tabula->nowmove = 1;				
			}		
			// who next move ?
			sprintf(tabula->exstatus,"who next move ?");
			if ( tabula -> MaxGame == 60 && ( i==1 || i==2 || i==3) ) {
				memset(buff,0,MAXDATASIZE);	
				read_from_socket( tabula -> netgamer[1].socet ,buff,MAXDATASIZE,1 );
				memset(buff,0,MAXDATASIZE);	
				tabula->nowmove  = tabula->start;
				sprintf(buff,"%i \n",tabula->nowmove);
				write_to_socket(tabula -> netgamer[2].socet,buff,strlen(buff));
				write_to_socket(tabula -> netgamer[3].socet,buff,strlen(buff));	
			} else {			
				tabula->nowmove = whonext(tabula);
			}
			sprintf(tabula->exstatus,"tabula->nowmove %i",tabula->nowmove);			
/*			memset(buff,0,MAXDATASIZE);	
			read_from_socket( tabula -> netgamer[1].socet ,buff,MAXDATASIZE );			
			printf("\n !!!!!!!!!!!!!!!!! %s ",buff);
			write_to_socket(tabula -> netgamer[2].socet,buff,strlen(buff));
			write_to_socket(tabula -> netgamer[3].socet,buff,strlen(buff));
			sscanf(buff,"%i",&tmpval);
			tabula->nowmove = tmpval;
			printf("\n !!!!!!!!!!!!!!!!!! Next move %i ",tabula->nowmove);*/
			
		}
//		tabula->start ++;
//		if (tabula->start==4) tabula->start = 1;
paper:
		//      
		stataftercircle(tabula);
		// who next start ?	
/*		memset(buff,0,MAXDATASIZE);	
		read_from_socket( tabula -> netgamer[1].socet ,buff,MAXDATASIZE );			
		printf("\n next start %s ",buff);
		write_to_socket(tabula -> netgamer[2].socet,buff,strlen(buff));
		write_to_socket(tabula -> netgamer[3].socet,buff,strlen(buff));
		sscanf(buff,"%i",&tmpval);
		tabula->start = tmpval;*/
		tabula->nowmove = tabula->start = whonext(tabula);
		sprintf(tabula->exstatus,"tabula->start %i",tabula->start);
//		printf("\nsleep(1000)");
//		sleep(1000);
//	}	while ( 1 ) ;		
	}	while ( ! endofgame (tabula) ) ;
	tabula -> status = 3; // mast die & clean by master proc.
	termination_handler_children(SIGTERM);
	return 1;
	
}
//--------------------------------------------------------
int endofgame (Ttabula *tabula) {
	int i;
	for (i=1;i<=3;i++)
		if (tabula->nBullet > tabula->netgamer[i].nBullet)
			return 0;		
	return 1;
}
//--------------------------------------------------------
int whonext(Ttabula *tabula) {
	char buff[MAXDATASIZE];
	int retval;
	retval = 0;	
	memset(buff,0,MAXDATASIZE);	
	read_from_socket( tabula -> netgamer[1].socet ,buff,MAXDATASIZE,1 );			
//	printf("\n next  %s ",buff);
	write_to_socket(tabula -> netgamer[2].socet,buff,strlen(buff));
	write_to_socket(tabula -> netgamer[3].socet,buff,strlen(buff));
	sscanf(buff,"%i",&retval);
	return retval;	
}
//--------------------------------------------------------
int stataftercircle(Ttabula *tabula) {
		char buff[MAXDATASIZE];
		int i,lastbullet;
		char *pbuff;
		
		//           3 		
		for (i = 1;i<=3;i++) {
			lastbullet = 0;
//			printf("\n after circle for gamer %i",i);
			memset(buff,0,MAXDATASIZE);	
			read_from_socket( tabula -> netgamer[1].socet ,buff,MAXDATASIZE ,1); // bullet
			pbuff = buff;
       while ( sscanf(pbuff,"%i",&lastbullet) !=EOF  ) {
            if (lastbullet)
		          tabula ->netgamer[i].nBullet = lastbullet;
            pbuff = strchr(pbuff,' ')+1;
       }			
//			printf("\n %s",buff);
			memset(buff,0,MAXDATASIZE);	
			read_from_socket( tabula -> netgamer[1].socet ,buff,MAXDATASIZE,1 );
//			printf("\n %s",buff);			
			memset(buff,0,MAXDATASIZE);	
			read_from_socket( tabula -> netgamer[1].socet ,buff,MAXDATASIZE,1 );
//			printf("\n %s",buff);			
			memset(buff,0,MAXDATASIZE);	
			read_from_socket( tabula -> netgamer[1].socet ,buff,MAXDATASIZE,1);		
//			printf("\n %s",buff);			
		}
		return 1;
}
//--------------------------------------------------------
int hose_to_gamer(Ttabula *tabula,int i,char *buff) {
	memset(buff,0,MAXDATASIZE);	
	read_from_socket( tabula -> netgamer[i].socet,buff,MAXDATASIZE,1);
//	printf("\n hose_to_gamer read %s",buff);
	write_to_socket(getleftsocket(tabula -> netgamer[i].globalnumber,tabula),buff,strlen(buff) );
	write_to_socket(getrightsocket(tabula -> netgamer[i].globalnumber,tabula),buff,strlen(buff) );
//	printf("...ok");	
	return 1;
}
//--------------------------------------------------------
int write_to_gamer(Ttabula *tabula,int i,char *buff) {
			write_to_socket(tabula->netgamer[i].socet,buff,strlen(buff));
		// and for hose
			write_to_socket(getleftsocket(tabula->netgamer[i].globalnumber,tabula),buff,strlen(buff));
			write_to_socket(getrightsocket(tabula->netgamer[i].globalnumber,tabula),buff,strlen(buff));
			return 1;
}
//--------------------------------------------------------
int getleftsocket(int gnum,	Ttabula *tabula) {
	switch (gnum) {
		case 1:
			return tabula->netgamer[2].socketright;
		case 2:
			return tabula->netgamer[3].socketright;
		case 3:
			return tabula->netgamer[1].socketright;		
	}
//	printf("\nError:getleftsocket global num :%i",gnum);
//	printf("\n 3gm %i  1gm %i 2gm %i",tabula->netgamer[3].socketright,tabula->netgamer[1].socketright,tabula->netgamer[2].socketright);	
	return 0;
}
//--------------------------------------------------------
int getrightsocket(int gnum,	Ttabula *tabula) {
	switch (gnum) {
		case 1:
			return tabula->netgamer[3].socketleft;
		case 2:
			return tabula->netgamer[1].socketleft;
		case 3:
			return tabula->netgamer[2].socketleft;		
	}
//	printf("\nError:getrightsocket global num :%i",gnum);	
//	printf("\n 3gm %i  1gm %i 2gm %i",tabula->netgamer[3].socketleft,tabula->netgamer[1].socketleft,tabula->netgamer[2].socketleft);
	return 0;

}
//--------------------------------------------------------

#ifdef P4LIN
int slavejob(int t) {
	sleep(10000);
	return 1;
}
//--------------------------------------------------------
int superslavejob(int t) {
	sleep(10000);
	return 1;
}
#endif
//--------------------------------------------------------
int sendconnect(int t) {
	return write_to_socket ( t, CONNECTSIGN, strlen(CONNECTSIGN) );
}
//--------------------------------------------------------
int join(int t) {
	char buff[MAXDATASIZE];
	char nik[MAXDATASIZE];
	char passwd[MAXDATASIZE];
	
	int req,localnumber;	

//	printf("\nSing sending");	
	write_to_socket ( t, KPSIGN, strlen(KPSIGN) );
//	printf("\nSing sended");
	//     !
//	printf("\nReadign initial data");
	if (  read_from_socket(t,buff,MAXDATASIZE,1) < 0  )
		return (-1);
//	printf("\nInitial data readed");		
	sscanf(buff,"%i%s%s%i",&req,nik,passwd,&localnumber);
//	printf("\n%i %s %s %i\n",req,nik,passwd,localnumber);
	if (req) { //  
//		printf("\n     ");
		if ( ! makenewtabula(t,nik,passwd,localnumber) )
			return (-1);
			
	} else {
		if (localnumber != 1) {
			int todesk,master;
//			printf("\n   ");			
			todesk=0;
			master=0;
			//       4 
			//  ,     
			memset(buff,0,MAXDATASIZE);
			if (  read_from_socket(t,buff,MAXDATASIZE,1) < 0  )
				return (-1);
//			printf("%s ",buff);
			sscanf(buff,"%i%i",&todesk,&master);
//			printf("   %i   %i master %i",todesk,localnumber,master );
			if ( ! pipeconnect (t,todesk,localnumber,master) ) {
				return (-1); //  - 1  ̣
			}
//			printf("\n   !!!");			
		} else {
//			printf("\n     ");
			if ( ! getnoncomplecttabula (t,nik,passwd,localnumber) )
				return (-1);				
		}
	}	
	
	return ALLOK;
}
//-----------------------------------------
int pipeconnect (int t,int todesk,int localnumber,int masterglobalnumber) {
//		printf("\nBolvan desk=%i l=%i master=%i",todesk,localnumber,masterglobalnumber);
		if ( localnumber==2 ) {
			tabula[todesk].netgamer[masterglobalnumber].socketleft = t;
			return ALLOK; // all ok
		} else if ( localnumber==3 ) {
			tabula[todesk].netgamer[masterglobalnumber].socketright = t;		
			return ALLOK; // all ok			
		}
		return 0;

}
//-----------------------------------------
int getnoncomplecttabula(int t,char *nik,char *passwd,int localnumber) {
	char buff[MAXDATASIZE];
	int i;
	for (i=1; i < MAXGAMERS;i++) {
//		printf("\n  %i",i);
//		printf("  %i",tabula[i].desk);			
		if ( tabula[i].desk != 0 ) {
			//    - 
//			printf("\n   :%i  %i",i,MAXGAMERS);			
			if ( !gamer2desk(i,t,nik,passwd,localnumber) ) {
				sprintf(buff,"%i\n",0);
				write_to_socket ( t, buff, strlen(buff) );		
				return 0;
			}		
			return ALLOK;			
		}
	}		
//	printf("  ");
	return 0;
}
//-----------------------------------------
int makenewtabula(int t,char *nik,char *passwd,int localnumber) {
	int nBullet;
	int g61stalingrad;
	int g10vist;
	int globvist;

	char buff[MAXDATASIZE];
	int i;
	for (i=1; i < MAXGAMERS;i++) {
		if ( tabula[i].desk==0 ) {
			//   
			tabula[i].desk = i;
			tabulacounter++;
//			printf("\n  :%i  %i",i,MAXGAMERS);
		
			if ( !gamer2desk(i,t,nik,passwd,localnumber) ) {
//				sprintf(buff,"%i\n",0);
//				write_to_socket ( t, buff, strlen(buff) );				
				return 0;
			}
//			printf("\n   ");
/*	if (  read_from_socket(t,buff,MAXDATASIZE) < 0  )
				return (-1);*/
			memset(buff,0,MAXDATASIZE);
			read_from_socket(t,buff,MAXDATASIZE,1);
			
//			printf("\n  %s",buff);			
			sscanf(buff,"%i%i%i%i",&nBullet,&g61stalingrad,&g10vist,&globvist);
			tabula[i].nBullet = nBullet;
			tabula[i].g61stalingrad = g61stalingrad;
			tabula[i].g10vist = g10vist;
			tabula[i].globvist = globvist;
//			printf("\nIa %i %i %i %i\n",tabula[i].nBullet,tabula[i].g61stalingrad,tabula[i].g10vist,tabula[i].globvist);
			
//			sleep(100);

			
			return ALLOK;
			
		}
	}
		
//	printf("  ");
//	write_to_socket ( t, buff, strlen(buff) );	
	return 0;

}
//-----------------------------------------
int gamer2desk(int desk,int t,char *nik,char *passwd,int localnumber) {
	char buff[MAXDATASIZE];
	int j;
	for (j=1;j<=3;j++) {
//		printf("\ndesk=%i j=%i",desk,j);
		if ( !tabula[desk].netgamer[j].globalnumber ) {
			tabula[desk].netgamer[j].globalnumber = j;
			tabula[desk].netgamer[j].socet = t;
			tabula[desk].netgamer[j].localnumber = localnumber;
			strcpy(tabula[desk].netgamer[j].nik,nik);
			strcpy(tabula[desk].netgamer[j].passwd,passwd);
//			printf("\n   :%i  :%i",desk,j);
/*			
			sprintf(buff,"%i %i \n",desk,j);
			
			write_to_socket ( t, buff, strlen(buff) );	
//			sleep(1);
			//      !!!!
			sprintf(buff,"%i %i %i %i \n",tabula[desk].nBullet,tabula[desk].g61stalingrad,tabula[desk].g10vist,tabula[desk].globvist);
			write_to_socket ( t, buff, strlen(buff) );*/
			memset(buff,0,MAXDATASIZE);
			sprintf(buff,"%i %i %i %i %i %i \n",desk,j,tabula[desk].nBullet,tabula[desk].g61stalingrad,tabula[desk].g10vist,tabula[desk].globvist);
			write_to_socket ( t, buff, strlen(buff) );
			
			//  
			return ALLOK; // all ok
		}
	}
//	printf("\n    :%i",desk);
//	write_to_socket ( t, buff, strlen(buff) );	
	return 0; //    
}
//-----------------------------------------
Ttabula	*getdeskbysocket(int t) {
	int j,i;
	for (i=1; i < MAXGAMERS;i++) {
		if ( tabula[i].desk!=0 ) {
			for (j=1;j<=3;j++) {
				if ( tabula[i].netgamer[j].socet==t || tabula[i].netgamer[j].socketleft==t || tabula[i].netgamer[j].socketright==t) {
					return &tabula[i];
				}			
			}
		}
	}
	return NULL;
}
//-----------------------------------------
Tnetgamer *getnetgamerbysocket(int t) {
	int j,i;
	for (i=1; i < MAXGAMERS;i++) {
		if ( tabula[i].desk!=0 ) {
			for (j=1;j<=3;j++) {
				if ( tabula[i].netgamer[j].socet==t || tabula[i].netgamer[j].socketleft==t || tabula[i].netgamer[j].socketright==t) {
					return &tabula[i].netgamer[j];
				}			
			}
		}		
	}
	return NULL;	
}
//--------------------------------------------------------
void kprefserverstat(void) {
	int t,i;
	fprintf(stdout,"\nStatistics for %s\n",KPSIGN);
	fprintf(stdout,"\nStatus :0 empty,1 wait for gamers, 2 work 3 must die");
	for (t = 1;t<MAXGAMERS;t++) {
		if (tabula[t].desk) { // not empty desk
			fprintf(stdout,"\n ================== desk:%i ==================",tabula[t].desk);	
			fprintf(stdout,"\n status:%i exstatus:%s",tabula[t].status,tabula[t].exstatus);
			fprintf(stdout,"\n nowmove:%i start:%i MaxGame:%i",tabula[t].nowmove,tabula[t].start,tabula[t].MaxGame);
			fprintf(stdout,"\n nBullet:%i g61stalingrad:%i g10vist:%i globvist:%i",tabula[t].nBullet,tabula[t].g61stalingrad,tabula[t].g10vist,tabula[t].globvist);
			for (i=1	;i<=3;i++) {
				fprintf(stdout,"\n\n Gamer:%i",i);
				fprintf(stdout,"\n localnumber:%i globalnumber:%i nik:%s passwd:%s",tabula[t].netgamer[i].localnumber,tabula[t].netgamer[i].globalnumber,tabula[t].netgamer[i].nik,"**********");
				fprintf(stdout,"\n socet:%i socketleft:%i socketright:%i",tabula[t].netgamer[i].socet,tabula[t].netgamer[i].socketleft,tabula[t].netgamer[i].socketright);
				fprintf(stdout,"\n	GamesType:%i\n nBullet:%i\n",tabula[t].netgamer[i].GamesType,tabula[t].netgamer[i].nBullet);
			}
		} else {
			fprintf(stdout,"\ndesk:%i empty",t);
		}
	}	
}
//--------------------------------------------------------
void usage (char *name) {
	fprintf(stderr,"Usage: %s\n",name);
	fprintf(stderr,"-h or ? this help screen\n");
	fprintf(stderr,"-p PORT - port number\n");
	fprintf(stderr,"-l LOGFILE - log filename\n");	
	fprintf(stderr,"-s make statistics \n");
}

//--------------------------------------------------------
void killdesk(void) {
	int t,gamer;
	for (t = 1;t<MAXGAMERS;t++) {
		if (tabula[t].status == 3) {
			for (gamer =1 ;gamer <= 3;gamer++) {
                                #ifdef P4LIN
				close(tabula[t].netgamer[gamer].socet);
				close(tabula[t].netgamer[gamer].socketleft);
				close(tabula[t].netgamer[gamer].socketright);
                                #endif
                                #ifdef P4WIN
				closesocket(tabula[t].netgamer[gamer].socet);
				closesocket(tabula[t].netgamer[gamer].socketleft);
				closesocket(tabula[t].netgamer[gamer].socketright);

                                #endif

			}
			memset (&tabula[t],0,sizeof(Ttabula));	
		}
	}
}
//--------------------------------------------------------
void termination_handler_children (int signum) {
	keep_going = 0;
	signal (signum, termination_handler_children);
	killdesk();
        #ifdef P4LIN
	shmdt(tabula);
        #endif
        #ifdef P4WIN
//        GlobalUnlock(shmid);
        #endif

  exit(0);
}
//--------------------------------------------------------

void termination_handler (int signum) {
	keep_going = 0;
	signal (signum, termination_handler);
        killdesk();
        #ifdef P4LIN
	shmdt(tabula);
        shmctl(shmid, IPC_RMID, 0);
        #endif
        #ifdef P4WIN
        cleannetinmustdie();
//        GlobalUnlock(shmid);
//        GlobalFree(shmid);
	free(tabula);
        #endif
        exit(0);
}
//--------------------------------------------------------
void fireman(int signum)	 {
        #ifdef P4LIN
        while (waitpid(-1, NULL, WNOHANG) > 0)
                ;
        #endif
}
//--------------------------------------------------------
